<?php

use Core\Config;

if (!defined('GAME_VERSION')) {
    require_once '_incl_data/autoload.php';
}

if (isset($_GET['time'])) {
    echo time() . '<br>' . date('d.m.Y H:i:s', (int)$_GET['time']);
    die();
}

header("Cache-Control: max-age=3600");
?>
<!DOCTYPE html>
<html lang="ru">
<head>
    <title><?= Config::get('title') ?></title>
    <meta name="description" content="<?= Config::get('desc') ?>"/>
    <meta name="keywords" content="<?= Config::get('keys') ?>"/>
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0"/>
    <meta name="msapplication-config" content="browserconfig.xml"/>
    <link type="text/css" rel="stylesheet" href="stylen.css"/>
    <style>
        div.content {
            display: flex;
            justify-content: center;
            align-items: center;
            flex-direction: column;
            margin-top: 50px;
        }
        hr.incontent {
            width: 32%;
            border: 1px #1c1c1c solid;
        }
    </style>
</head>
<body>
<div class="page-background">
    <img class="img1" src="werhr.jpg" alt="Старый бойцовский клуб">
    <form action="/enter.php" method="post">
        <label for="first-name">Ваш Никнейм</label><br>
        <input type="text" id="first-name" name="login" autocomplete="username"><br>
        <label for="last-name">Ваш Пароль</label><br>
        <input type="password" id="last-name" name="psw" autocomplete="current-password">
        <p>
            <input type="submit" value="Войти в игру" class="btn btn-default">
    </form>
    <br/><br>
    <a href='/news' target="_blank">Новости проекта</a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <a href='/repass'>Восстановление пароля</a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <a href='/register'>Регистрация в игре</a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <a href='/forum' target="_blank">Форум проекта</a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <a href="/rating_pers" target="_blank">Рейтинг персонажей</a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
    <a href="/rating_clans" target="_blank">Рейтинг кланов</a> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;

    <div class="content">
        <h3>Новый Бойцовский Клуб</h3>
        <small class="megatext">
            <strong>Новый Бойцовский Клуб</strong> — это проект, предоставляющий возможность окунуться в игровой мир
            <strong> старого «Бойцовского Клуба»</strong>. <strong>Бойцовский клуб «combats.com» </strong> — это
            бесплатная
            браузерная игра, которая является одним из родоначальников жанра BBMMORPG. В <strong>«Бойцовский клуб
                играть»</strong> Вы сможете лишь имея доступ к интернету, используя любой веб браузер.

            За основу взята старая версия игры <strong>«combats.com»</strong> за 2006-2009 года. Мы постарались
            сохранить все лучшие традиции старой версии бойцовского клуба и добавили массу новых обновлений и
            нововведений. Как и в старой доброй
            игре <strong>«Бойцовский Клуб»</strong>, Вас ждёт масса эпических сражений между игроками, кланами,
            склонностями. В зависимости от Вашего выбора персонаж будет иметь определенную склонность, которые
            отлично помогут усилить вашего
            персонажа.

            В процессе игры Вас ждет масса интересного общения в чате с другими игроками, более того, Вы можете
            использовать голосовые сообщения, чтобы облегчить процесс коммуникации с игроками и вникания в проект
            «Старого Бойцовского Клуба». В
            зависимости от игровых предпочтений каждый игрок сможет вступать в различные игровые кланы или же
            создать свой собственный, став главой клана.

            Для каждого клана и каждого персонажа в отдельности предусмотрен динамический игровой рейтинг игроков и
            кланов, а так же ежедневные игровые события, которые не оставят игроков со скукой на едине, клановых
            сражений, проведения
            хаотических поединков. Ну а если у Вас возникнут трудности с игрой, служба поддержки всегда готова Вам
            помочь и ответить на ваши игровые вопросы, ну а если и это не поможет - <strong>гайды на форуме
                проекта</strong> всегда прийдут на
            помощь и подскажут Вам, как правильно прокачивать вашего персонажа.

            Желаем Вам побед и преданных союзников в <strong> проекте «Нового Бойцовского Клуба»</strong>.
        </small>
        <hr class="incontent">

        <h3>Игровой мир «Бойцовский клуб»</h3>
        <small class="megatext">
            Игровой процесс сохранен в жанре <strong>старого бойцовского клуба «oldbk»</strong>.
            Ваш персонаж создается в <strong>мире Новый Бойцовский Клуб</strong>. При создании персонажа Вас
            ждет выбор пути <strong>Одного из
                четырех магов ( Воздуха, Воды, Огня или Земли ) или же Одного из пяти воинов ( Критовик, Уворот,
                Танк, Топор, Критоуворот )</strong>. В самой игре Вас ждет масса локаций, где Вы сможете
            обмениваться боевым опытом, повышать
            мастерство, прокачивать своего героя. Если возникнут какие — либо вопросы на помощь всегда придут
            подсказки в общем чате или статьи в новостях проекта.

            Основой игрового процесса являются хаотические поединки, а так же обычные физические поединки,
            которые вы осуществляете с другими персонажами. Каждый бой заключается в обмене ударами с
            противником с использованием приемов. Чем больше
            поединков Вы проводите, тем сильнее становится персонаж. Каждые выходные, мы увеличиваем награду за
            проведение поединков для наших любимых игроков.

            Стиль боя сохранен также в традициях <strong>старого бойцовского клуба «combats.com»</strong>.
            Тактику и развитие персонажа Вы выбираете по своему желанию.

            Также Вас ждут захватывающие походы в пещеры, а именно Катакомбы, Бездная, Пещера Мглы, Потерянный
            Вход, Пещера Тысячи Проклятий, Тропа Инвизиции, Гора Легиона, Туманные Низины, Грибница или
            Канализация, ну а в дополнение у Вас будет
            возможность проверить своего бойца в Изломе Хаоса.
        </small>
        <hr class="incontent">

        <h3>Социальная составляющая игры «Бойцовский клуб».</h3>
        <small class="megatext">
            <strong>Новый Бойцовский клуб</strong> - это игра, которая покорила сердца многих
            пользователей рунета в 2004 — 2009 годах. <strong>«combats.com»</strong> версии 2, отличался особым
            жанром игры на тот момент — MMORPG.
            Одной из основных особенностей игры <strong>«Бойцовский Клуб»</strong>, помимо захватывающих боев,
            также являлась социальная составляющая.

            В процессе игры каждый игрок имел возможность общаться с другими игроками в общем, клановом или
            приватном чате. Обмениваться опытом, делиться важной информацией или просто весело проводить время.
            При отсутствии социальных сетей в тот
            момент — это было немаловажным фактором для выбора подходящих проектов <strong>«Браузерной
                Игры»</strong>.

            В проекте <strong>Новый Бойцовский Клуб</strong> также сохранен стиль общения <strong>«Старого
                Бойцовского Клуба»</strong>, а так же добавлена уникальная в своем роде функция: <strong>Голосовые
                Сообщения</strong>.
        </small>
        <hr class="incontent">
        <div>
            <a href="/encicl/law2.html" target="_blank">Пользовательское Соглашение</a> &nbsp;&nbsp;&nbsp;
            <a href="/encicl/law3.html" target="_blank">Политика Конфиеденцальности</a>&nbsp;&nbsp;&nbsp;
            <a href="/encicl/law4.html" target="_blank">Публичный договор оферты</a>&nbsp;&nbsp;&nbsp;
            <a href="/support/index.php" target="_blank">Поддержка</a> &nbsp;&nbsp;&nbsp;
            <a href="/contacts.html" target="_blank">Контакты</a> &nbsp;&nbsp;&nbsp;
        </div>
    </div>
</div>
</body>
</html>
